# node-mp4-parser

[![Build Status](https://travis-ci.org/pipll/node-mp4-parser.svg?branch=master)](https://travis-ci.org/pipll/node-mp4-parser) [![npm](https://img.shields.io/npm/v/node-mp4-parser.svg)](https://www.npmjs.com/package/node-mp4-parser) [![Code Climate](https://codeclimate.com/github/pipll/node-mp4-parser/badges/gpa.svg)](https://codeclimate.com/github/pipll/node-mp4-parser) ![GitHub license](https://img.shields.io/github/license/pipll/node-mp4-parser.svg)

Node.js MP4 video parser

## Installation

```
npm install node-mp4-parser
```

## Usage

```javascript
const fs = require('fs');
const Parser = require('node-mp4-parser');

fs.open('/path/to/file.mp4', 'r', function(fd) {
    try {
        let movie = Parser.parse(fd);
        // Work with movie
        // https://github.com/pipll/node-video-common#movie
        console.log('Duration:', movie.relativeDuration());
    } catch (ex) {
        console.error('Error:', ex);
    } finally {
        fs.close(fd);
    }
});
```
